﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Problems.DataAnalysis;

namespace HeuristicLab.Algorithms.NCA {
  [Item("NCAClassificationSolution", "")]
  [StorableClass]
  public class NCAClassificationSolution : ClassificationSolution, INCAClassificationSolution {

    public new INCAModel Model {
      get { return (INCAModel)base.Model; }
      set { base.Model = value; }
    }

    [StorableConstructor]
    private NCAClassificationSolution(bool deserializing) : base(deserializing) { }
    private NCAClassificationSolution(NCAClassificationSolution original, Cloner cloner)
      : base(original, cloner) {
    }
    public NCAClassificationSolution(IClassificationProblemData problemData, INCAModel ncaModel)
      : base(ncaModel, problemData) {
      RecalculateResults();
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new NCAClassificationSolution(this, cloner);
    }

    protected override void RecalculateResults() {
      CalculateResults();
    }
  }
}
